--
-- JD7RSeries
-- Specialization class for JD7RSeries
-- @Authors of original scripts used: Manuel Leithner (SFM-Modding),Modelleicher (www.schwabenmodding.bplaced.net),Templaer, JoXXer, Knagsted, Mofa-Killer, Face, Heady, other do not remember!!
-- @author  Ago-Systemtech
-- 
-- @DATE  24/12/14 ADD FIX FOR USE JD 7R SERIES, FS15 Ago-Systemtech(alias Ago-Modding): https://www.facebook.com/ago.systemtech (Modhoster Team)
---- FIX FS17 BY MOGLI 29/11/2017---------
------ free for non commercial-usage -------------
JD7RSeries = {};
function JD7RSeries.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
function JD7RSeries:load(savegame)
    self.isSelectable = true
    ---------------------CAM INTERNA MOBILE---------------------
    self.internalCamera = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.internalCamera#index"));
    self.camPositionX = 0;
    self.camPositionZ = 0;
    self.camPositionY = 0;
            
    self.updateFuelIndicators = SpecializationUtil.callSpecializationsFunction("updateFuelIndicators");
    self.ledriserva = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.ledriserva#index"));
    self.ledriservaActive = false;
    self.riserva = 60;
    ------------REALISTIC INDOOR CAM------------
    self.ric = {};
    self.ric.directionPart = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.realisticIndoorCam#directionPart"));
    ----------------------- FRONT WIPER ANIMATION---------------------
    local wiperFrontAnimRootNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.wiperFront#rootNode"));
    self.wiperFrontAnimCharSet = 0;
    if wiperFrontAnimRootNode ~= nil and wiperFrontAnimRootNode ~= 0 then
        self.wiperFrontAnimCharSet = getAnimCharacterSet(wiperFrontAnimRootNode);
        if self.wiperFrontAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperFrontAnimCharSet, getXMLString(self.xmlFile, "vehicle.wiperFront#clip"));
            assignAnimTrackClip(self.wiperFrontAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperFrontAnimCharSet, 0, true);
            local wiperFrontAnimSpeedScale = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.wiperFront#speedScale"), 1);
            setAnimTrackSpeedScale(self.wiperFrontAnimCharSet, 0, wiperFrontAnimSpeedScale);
            self.wiperFrontAnimDuration = getAnimClipDuration(self.wiperFrontAnimCharSet, clip);
        end;
    end;
    self.iswiperFrontActive = false;
    self.finishwiperFront = true;
    --------------------------REAR WIPER ANIMATION----------------------
    local wiperBackAnimRootNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.wiperBack#rootNode"));
    self.wiperBackAnimCharSet = 0;
    if wiperBackAnimRootNode ~= nil and wiperBackAnimRootNode ~= 0 then
        self.wiperBackAnimCharSet = getAnimCharacterSet(wiperBackAnimRootNode);
        if self.wiperBackAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperBackAnimCharSet, getXMLString(self.xmlFile, "vehicle.wiperBack#clip"));
            assignAnimTrackClip(self.wiperBackAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperBackAnimCharSet, 0, true);
            local wiperBackAnimSpeedScale = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.wiperBack#speedScale"), 1);
            setAnimTrackSpeedScale(self.wiperBackAnimCharSet, 0, wiperBackAnimSpeedScale);
            self.wiperBackAnimDuration = getAnimClipDuration(self.wiperBackAnimCharSet, clip);
        end;
    end;
    self.iswiperBackActive = false;
    self.finishwiperBack = true;    
    -------------------------- LEVE ----------------------
    self.levaindicatori = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.levaindicatori#index"));
    self.LevaHandbrake = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LevaHandbrake#index"));
     
    --------------------------LED-------------------------
    self.handbrakelight = Utils.indexToObject(self.rootNode, getXMLString(self.xmlFile, "vehicle.handbrakelight#index"));
    self.olioicona = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.olioicona#index"));
    self.tachiicona = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.tachiicona#index"));
    self.LedHazard = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedHazard#index"));
    self.ledLampeggiante = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.ledLampeggiante#index"));
    self.LedStart = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedStart#index"));
    self.Hire = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Hire#index"));
    self.Green = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Green#index"));
    self.quadroOFF = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.quadroOFF#index"));
	self.led4WDon = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Led4WDon#index"));
    self.led4WDoff = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Led4WDoff#index"));
    self.led4WDoff2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Led4WDoff2#index"));
    self.LedBraccio = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LedBraccio#index"));
    self.PTOLed = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.PTOLed#index"));
    self.frontled = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.frontled#index"));
    self.reverseled = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.reverseled#index"));
	self.folleled = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.folleled#index"));
    ------------------ SWITCHES---------------
    self.numSwitches = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.switches#count"),0);
    self.switch = {};
    for i=1, self.numSwitches do
        local objname = string.format("vehicle.switches.switch" .. "%d", i);
        self.switch[i] = {};
        self.switch[i] = Utils.indexToObject(self.components, getXMLString(self.xmlFile, objname .. "#index"));
    end;
    ----------------- GASOLIO INDICATORI----------
    self.fuelIndicatorsGroup = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.fuelIndicators#index"));
    self.numFuelIndicators = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.fuelIndicators#count"), 0);
    self.fuelIndicators = {};
    for i=1, self.numFuelIndicators do
        local objname = string.format("vehicle.fuelIndicators.fuelIndicator" .. "%d", i);
        self.fuelIndicators[i] = {};
        self.fuelIndicators[i].rotNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, objname .. "#rotNode"));
        setVisibility(self.fuelIndicators[i].rotNode,true);
    end;
     --------------------------GIUNTI ASSALE------------------------
    self.giuntoDestro = {};
    self.giuntoDestro.node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.giuntoDestro#index"));
    self.giuntoDestro.speedFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.giuntoDestro#speedFactor"), 2);
    self.giuntoSinistro = {};
    self.giuntoSinistro.node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.giuntoSinistro#index"));
    self.giuntoSinistro.speedFactor = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.giuntoSinistro#speedFactor"), 2);
    -----------------SOUND RISERVA------------------
    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
    self.playedSound = false;
	
	self.Jd7R_puleggeAnim = getXMLString(self.xmlFile, "vehicle.puleggeAnimation#animName");
	self.Jd7R_speedDivider = getXMLInt(self.xmlFile, "vehicle.puleggeAnimation#speedDivider");
	if self.Jd7R_puleggeAnim ~= nil and self.Jd7R_speedDivider ~= nil then
		self.Jd7R_initalized = true;
	else
		self.Jd7R_initalized = false;
	end
    
    -- MOGLI START --
    ---------------FREEEZE STEERING---------------
    self.freezeRotatedTime = 0
    -- self.getIsActiveForInputNew =JD7RSeries.getIsActiveForInputNew
    self.getIsActiveForInput = JD7RSeries.getIsActiveForInputNew
    -- MOGLI END --
end;
function JD7RSeries:delete() 
end;
function JD7RSeries:readStream(streamId, connection)        
end;
function JD7RSeries:writeStream(streamId, connection)
end;
function JD7RSeries:readUpdateStream(streamId, timestamp, connection)
end;
function JD7RSeries:writeUpdateStream(streamId, connection, dirtyMask)
end;
function JD7RSeries:mouseEvent(posX, posY, isDown, isUp, button)
end;
function JD7RSeries:keyEvent(unicode, sym, modifier, isDown)    
end;
    -- MOGLI START --
    
function JD7RSeries:getIsActiveForInputNew(onlyTrueIfSelected)
    if g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen then
        return false;
    end;
    if self.isEntered then
        if onlyTrueIfSelected == nil or onlyTrueIfSelected then
            return self.selectedImplement == nil;
        else
            return true;
        end;
    end;
    return false;
end;
    -- MOGLI END --
function JD7RSeries:update(dt)
    -------------LIFT-HIDRO----------------
    if self:getIsActive() then
    --------------------------GIUNTI ASSALE------------------------
        local x,y,z = getRotation(self.wheels[1].driveNode);
        setRotation(self.giuntoDestro.node, 0 ,0, x*self.giuntoDestro.speedFactor);
        local x,y,z = getRotation(self.wheels[1].driveNode);
        setRotation(self.giuntoSinistro.node, 0 ,0, x*self.giuntoSinistro.speedFactor);
    end;
    ------------------LED RISERVA----------------------
    if self.isEntered then
        if self.fuelFillLevel < 60 then
            self.riserva = self.riserva - dt;
            if self.playedSound == false then
                playSample(self.fuelwarningSoundId,1,1,0);
                self.playedSound = true;
            end;
            self.ledriservaActive = true;
        else
            self.playedSound = false;
            self.ledriservaActive = false;
        end;
        setVisibility(self.ledriserva,self.ledriservaActive);
        self:updateFuelIndicators();
    end;
    ---------------------CAM INTERNA MOBILE---------------------
     if self.camIndex == 2 then
     if self:getIsActive() then
        if InputBinding.isPressed(InputBinding.MOVECAMLEFT2) then
            self.camPositionX = self.camPositionX + 0.03;
            if self.camPositionX >= 0.3 then
                self.camPositionX = 0.3;
            end;
        end;
        if InputBinding.isPressed(InputBinding.MOVECAMRIGHT2) then
            self.camPositionX = self.camPositionX - 0.03;
            if self.camPositionX <= -0.3 then
                self.camPositionX = -0.3;
            end;
        end;
        if InputBinding.isPressed(InputBinding.MOVECAMFORWARD2) then
            self.camPositionZ = self.camPositionZ + 0.03;
            if self.camPositionZ >= 0.3 then
                self.camPositionZ = 0.3;
            end;
        end;
                if InputBinding.isPressed(InputBinding.MOVECAMBACK2) then
            self.camPositionZ = self.camPositionZ - 0.03;
            if self.camPositionZ <= -0.22 then
                self.camPositionZ = -0.22;
            end;
        end;
        if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
            self.camPositionY = self.camPositionY + 0.02;
            if self.camPositionY >= 0.15 then
                self.camPositionY = 0.15;
            end;
        end;
        if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
            self.camPositionY = self.camPositionY - 0.02;
            if self.camPositionY <= -0.2 then
                self.camPositionY = -0.2;
            end;
        end;
        if Input.isKeyPressed(Input.KEY_z) then
            self.camPositionX = 0;
            self.camPositionZ = 0;
            self.camPositionY = 0;
        end;
        if self.internalCamera ~= nil then
            setTranslation(self.internalCamera, self.camPositionX, self.camPositionZ, self.camPositionY);
        end;
       end;
    end;
    --------------REALISTIC INDOOR CAM------------------------
    if self:getIsActive() then
            local ax, ay, az = getWorldTranslation(self.ric.directionPart);
            local bx = 0;
            local by = 1100000;
            local bz = 0;
            x, y, z = worldDirectionToLocal(getParent(self.ric.directionPart), bx-ax, by-ay, bz-az);
            setDirection(self.ric.directionPart, x, y, z, 0, 0, 1);
    end;
    
    if self:getIsActive() then
        if self.isHired == true then
            setVisibility(self.Hire, true);
            setVisibility(self.Green, false);
        else
            setVisibility(self.Hire, false);
            setVisibility(self.Green, true);
        end;
    end;
	    if not self.Jd7R_initalized then
		return;
	end
	if self:getIsMotorStarted() then
		self:playAnimation(self.Jd7R_puleggeAnim, 
							self.motor.lastMotorRpm / self.Jd7R_speedDivider, 
							self:getAnimationTime(self.Jd7R_puleggeAnim), 
							true);
	else
		self:stopAnimation(self.Jd7R_puleggeAnim);
	end
    
end;
function JD7RSeries:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;
function JD7RSeries:updateTick(dt)
    -- MOGLI START --
    ---------------FREEEZE STEERING---------------
    if self.isMotorStarted then    
        self.freezeRotatedTime = self.rotatedTime
    elseif self:getIsActive() then
        self.rotatedTime = self.freezeRotatedTime
    end;
    -- MOGLI END --
    
    if self.isMotorStarted then
             setVisibility(self.olioicona, false);
            setVisibility(self.tachiicona, true);
              setVisibility(self.LedStart, true);
            setVisibility(self.quadroOFF, true);
            
            setVisibility(self.fuelIndicatorsGroup, true);
            -- setVisibility(self.LedBraccio, true);
        else
            
            setVisibility(self.olioicona, true);
            setVisibility(self.tachiicona, false);
            setVisibility(self.LedStart, false);
            setVisibility(self.quadroOFF, false);
            
            setVisibility(self.fuelIndicatorsGroup, false);
            -- setVisibility(self.LedBraccio, false);
        end;
    if self:getIsActive() then
        
        for k, implement in pairs(self.attachedImplements) do
                if implement.object ~= nil then
                    if implement.object.isTurnedOn then
                        setVisibility(self.PTOLed, true);
                    else
                        setVisibility(self.PTOLed, false);
                    end;
                end;                
        end;
 end;
	-- if self.levaindicatori ~= nil then
        -- local targetAngle = 0
        -- if     self.turnLightState == Vehicle.TURNLIGHT_LEFT then 
            -- targetAngle = 20
        -- elseif self.turnLightState == Vehicle.TURNLIGHT_RIGHT then 
            -- targetAngle = -20
        -- end
        -- setRotation( self.levaindicatori, 0, 0, math.rad( targetAngle ) )
    -- end
    
    -- if self.LedHazard  ~= nil then
        -- if self.turnSignalState == Vehicle.TURNSIGNAL_HAZARD then
            -- setVisibility(self.LedHazard , true);
        -- else
            -- setVisibility(self.LedHazard , false);
        -- end;
    -- end;
    
    ----------- WIPERS -----------------
    if self.isMotorStarted then
        if not self.finishwiperFront then
            if getAnimTrackTime(self.wiperFrontAnimCharSet, 0) % self.wiperFrontAnimDuration <= 100 then
                setAnimTrackTime(self.wiperFrontAnimCharSet, 0, 0.0);
                disableAnimTrack(self.wiperFrontAnimCharSet, 0);
                self.finishwiperFront = true;
            end;
        end;
        if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
            if not self.iswiperFrontActive then
                enableAnimTrack(self.wiperFrontAnimCharSet, 0);
                self.iswiperFrontActive = true;
            end;
        else
            if self.iswiperFrontActive then
                self.iswiperFrontActive = false;
                self.finishwiperFront = false;
            end;
        end;
        
        if not self.finishwiperBack then
            if getAnimTrackTime(self.wiperBackAnimCharSet, 0) % self.wiperBackAnimDuration <= 100 then
                setAnimTrackTime(self.wiperBackAnimCharSet, 0, 0.0);
                disableAnimTrack(self.wiperBackAnimCharSet, 0);
                self.finishwiperBack = true;
            end;
        end;
        if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 then
            if not self.iswiperBackActive then
                enableAnimTrack(self.wiperBackAnimCharSet, 0);
                self.iswiperBackActive = true;
            end;
        else
            if self.iswiperBackActive then
                self.iswiperBackActive = false;
                self.finishwiperBack = false;
            end;
        end;
        for _, part in pairs(self.movingParts) do
            part.isDirty = true;
        end;
    end;
    --------------------SWITCH------------------------------
    if self.switch[1] ~= nil then
        if self.isMotorStarted then
            setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(-60));
        else
            setRotation(self.switch[1], math.rad(0), math.rad(0), math.rad(0));
        end;
    end;
	local dir = self.movingDirection
		local handbrake = false
		if      self.mrGbMS ~= nil
				and self:mrGbMGetIsOn()
				and self.mrGbMS.Handbrake then
			handbrake = true

		
		handbrake = true
		end
    if self.l2gsGetShuttleDirection ~= nil then
      dir = self:l2gsGetShuttleDirection()
    elseif  self.dCcheckModule ~= nil 
        and self.driveControl  ~= nil
        and self:dCcheckModule("shuttle")
			  and self.driveControl.shuttle.isActive then
			dir = self.driveControl.shuttle.direction
		end
		if handbrake then
			dir = 0	
		-- if self.LevaHandbrake ~= nil then
			-- setTranslation(self.LevaHandbrake, 0, 0.03159, math.abs(0));
		-- end	
		      setVisibility(self.handbrakelight, true);
        else
            setVisibility(self.handbrakelight, false);
		end
		
    if     dir > 0 then
      setVisibility(self.frontled, true);
      setVisibility(self.reverseled, false);
      setVisibility(self.folleled, false);
      if self.LevaHandbrake ~= nil then
			  setTranslation(self.LevaHandbrake, -0.01908, 0.03159,  math.abs(0.02834));
			end
    elseif dir < 0 then
      setVisibility(self.reverseled, true);
      setVisibility(self.frontled, false);
      setVisibility(self.folleled, false);
			if self.LevaHandbrake ~= nil then
			  setTranslation(self.LevaHandbrake, -0.01908, 0.03159,  math.abs(0.00198));
			end
    else
      setVisibility(self.reverseled, false);
      setVisibility(self.frontled, false);
      setVisibility(self.folleled, true);
			if self.LevaHandbrake ~= nil then
			  setTranslation(self.LevaHandbrake, 0, 0.03159,  math.abs(0.02743));
       end;
    end
    if self.ledLampeggiante ~= nil then
         if self.beaconLightsActive then
            setVisibility(self.ledLampeggiante, true);
         else
           setVisibility(self.ledLampeggiante, false);
        end;
    end;
  end;
 
function JD7RSeries:updateFuelIndicators()
    local amountOfFuelPerIndicator = self.fuelCapacity/11;
    local timesToIterate = self.fuelFillLevel/amountOfFuelPerIndicator;
    timesToIterate = math.floor(timesToIterate);
    if self.oldTimesToIterate ~= timesToIterate then
        for i=1, self.numFuelIndicators do
            setVisibility(self.fuelIndicators[i].rotNode, false);
        end;
        for i=1, timesToIterate do
            setVisibility(self.fuelIndicators[i].rotNode, true);
        end;
    end;
    self.oldTimesToIterate = timesToIterate;
end;
function JD7RSeries:draw()
     if self.l2gsDrawShuttleDirection ~= nil then
         self:l2gsDrawShuttleDirection()
    end;    
end;
function JD7RSeries:onEnter()
        if self.isMotorStarted then
            setVisibility(self.olioicona, false);
            setVisibility(self.tachiicona, true);
            setVisibility(self.LedStart, true);
            setVisibility(self.quadroOFF, true);
    
        else
            setVisibility(self.olioicona, true);
            setVisibility(self.tachiicona, false);
            setVisibility(self.LedStart, false);
            setVisibility(self.quadroOFF, false);
        end
    if self.iswiperFrontActive then
        enableAnimTrack(self.wiperFrontAnimCharSet, 0);
    end;
        if self.iswiperBackActive then
        enableAnimTrack(self.wiperBackAnimCharSet, 0);
    end;
end;
function JD7RSeries:onLeave()
        if self.isMotorStarted then
            setVisibility(self.olioicona, false);
            setVisibility(self.tachiicona, true);
            setVisibility(self.LedStart, true);
            setVisibility(self.quadroOFF, true);
    
        else
            setVisibility(self.olioicona, true);
            setVisibility(self.tachiicona, false);
            setVisibility(self.LedStart, false);
            setVisibility(self.quadroOFF, false);
            
         end
    if self.iswiperBackActive then
        disableAnimTrack(self.wiperBackAnimCharSet, 0);
    end;
        if self.iswiperFrontActive then
        disableAnimTrack(self.wiperFrontAnimCharSet, 0);
    end;
end;